%bcond_with bootstrap

Summary:        Extract class/interface/method definitions from sources
Name:           qdox
Version:        2.0.0
Release:        6%{?dist}
License:        ASL 2.0
URL:            https://github.com/paul-hammant/qdox
Source0:        https://repo1.maven.org/maven2/com/thoughtworks/qdox/qdox/%{version}/qdox-%{version}-project.tar.gz
Source1:        qdox-MANIFEST.MF
Patch3000:      0001-Port-to-JFlex-1.7.0.patch

BuildRequires:  byaccj
%if %{with bootstrap}
BuildRequires:  javapackages-bootstrap
%else
BuildRequires:  maven-local
BuildRequires:  jflex
%endif

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

%description
QDox is a high speed, small footprint parser
for extracting class/interface/method definitions
from source files complete with JavaDoc @tags.
It is designed to be used by active code
generators or documentation tools.

%package javadoc
Summary:        Javadoc for %{name}

%description javadoc
API docs for %{name}.



%prep
%autosetup -p1

find -name '*.jar' -delete
find -name '*.class' -delete
rm -r bootstrap

%pom_remove_parent

%pom_remove_plugin :animal-sniffer-maven-plugin
%pom_remove_plugin :maven-assembly-plugin
%pom_remove_plugin :maven-failsafe-plugin
%pom_remove_plugin :maven-invoker-plugin
%pom_remove_plugin :maven-jflex-plugin
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :exec-maven-plugin

%mvn_file : %{name}
%mvn_alias : qdox:qdox



%build
%{?jpb_env}

jflex -d src/main/java/com/thoughtworks/qdox/parser/impl src/grammar/lexer.flex
jflex -d src/main/java/com/thoughtworks/qdox/parser/impl src/grammar/commentlexer.flex

(cd ./src/main/java/com/thoughtworks/qdox/parser/impl
 byaccj -v -Jnorun -Jnoconstruct -Jclass=DefaultJavaCommentParser -Jpackage=com.thoughtworks.qdox.parser.impl ../../../../../../../grammar/commentparser.y
 byaccj -v -Jnorun -Jnoconstruct -Jclass=Parser -Jimplements=CommentHandler -Jsemantic=Value -Jpackage=com.thoughtworks.qdox.parser.impl -Jstack=500 ../../../../../../../grammar/parser.y
)

%mvn_build -f -- -Dmaven.compiler.source=1.7 -Dmaven.compiler.target=1.7

jar ufm target/%{name}-%{version}.jar %{SOURCE1}



%install
%mvn_install



%files -f .mfiles
%license LICENSE.txt
%doc README.md

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt



%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.0-6
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.0-5
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 19 2023 Zhao Zhen <jeremiazhao@tencent.com> - 2.0.0-4
- switched to non-bootstrap building

* Fri Apr 14 2023 Zhao Zhen <jeremiazhao@tencent.com> - 2.0.0-3
- rebuilding for opencloudos

* Fri Mar 24 2023 Shuo Wang <abushwang@tencent.com> - 2.0.0-2
- rebuilding for opencloudos

* Fri Mar 24 2023 Shuo Wang <abushwang@tencent.com> - 2.0.0-1
- initial build